package org.gcube.portlets.user.geoportaldataviewer;

import org.gcube.application.geoportal.managers.AbstractRecordManager;
import org.gcube.application.geoportal.managers.ManagerFactory;
import org.gcube.application.geoportal.model.Record;
import org.gcube.application.geoportal.model.concessioni.Concessione;
import org.gcube.common.scope.api.ScopeProvider;
import org.gcube.portlets.user.geoportaldataviewer.server.ConvertToDataViewModel;
import org.gcube.portlets.user.geoportaldataviewer.server.GeoportalDataViewerServiceImpl;
import org.gcube.portlets.user.geoportaldataviewer.shared.products.ConcessioneDV;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class GetConcessione {
	
	private static final Logger LOG = LoggerFactory.getLogger(GetConcessione.class);
	
	public static String SCOPE = "/gcube/devNext/NextNext";
	public static long concessioneId = 16;
	
	/*public static void main(String[] args) {
		
		ScopeProvider.instance.set(SCOPE);
		
//		Concessione loaded=(Concessione) ManagerFactory.getByRecordID(concessioneId).getRecord();
//		LOG.info("Loaded bean : "+loaded);
		
		try {
			LOG.info("Trying to get record for id "+concessioneId);
			AbstractRecordManager<Record> abmRecord = ManagerFactory.getByRecordID(concessioneId);
			LOG.info("Got record for id "+concessioneId);
			Record record = abmRecord.getRecord();
			Concessione concessione = null;
			if(record !=null && record instanceof Concessione) {
				concessione = (Concessione) record;
				LOG.info("To concessione view model:" +ConvertToDataViewModel.toConcessione(concessione).toString());
			}else {
				LOG.warn("No Record with id '"+concessioneId+"' is available");
			}
		}catch (Exception e) {
			String erroMsg = Concessione.class.getSimpleName() +" with id "+concessioneId+" not available";
			LOG.error(erroMsg,e);
		}
	}*/
	
	public static void main(String[] args) throws Exception {
		GeoportalDataViewerServiceImpl geonNaServiecImpl = new GeoportalDataViewerServiceImpl();
		ScopeProvider.instance.set(SCOPE);
		LOG.info("Trying to get record for id "+concessioneId);
		ConcessioneDV concessione = geonNaServiecImpl.getConcessioneForId(concessioneId);
		LOG.info("Got record for id "+concessione);
	}


}
